"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class KatrineAction {
    constructor(route, actionMethodName, requestType, controllerClass) {
        this.accessRules = [];
        this.route = route;
        this.actionMethodName = actionMethodName;
        this.requestType = requestType;
        this.controllerName = controllerClass.constructor.name;
        this.controllerClass = controllerClass;
    }
    setInvoker(boundMethod) {
        this.boundMethod = boundMethod;
    }
    invoke(...args) {
        if (this.boundMethod) {
            return this.boundMethod(...args);
        }
        return '';
    }
    getActionMethodName() {
        return this.actionMethodName;
    }
    getRequestType() {
        return this.requestType;
    }
    getRoute() {
        return this.route;
    }
    getControllerClass() {
        return this.controllerClass;
    }
    getControllerName() {
        return this.controllerName;
    }
    getController() {
        return this.controller;
    }
    setController(controller) {
        this.controller = controller;
    }
    addAccessRule(rule) {
        this.accessRules.push(rule);
    }
    canAccess(req) {
        return !!this.accessRules.find(rule => !rule.canAccess(req));
    }
}
exports.default = KatrineAction;
