import { AccessTypeable, KatrineActionInterface, ProjectMetadataInterface } from '../@types';
/**
 * Central element for Initialization and build Katrine components (controllers, actions, access rules e.t.c).
 */
declare class ProjectMetadata implements ProjectMetadataInterface {
    private _actions;
    private _rawControllers;
    private _controllerInstances;
    private _boundedActions;
    private _accessRules;
    getActions(): KatrineActionInterface[];
    hasAnyActions(): boolean;
    getActionByRoute(route: string): KatrineActionInterface;
    storeAction(action: KatrineActionInterface): void;
    addAccessByRoleRule(ruleData: AccessTypeable, actionName: string, controller: any): void;
    addController(controllerName: string, controller: any): void;
    private compileAction;
    private applyAccessRulesToAction;
    private findAccessRulesForAction;
    private makeKeyByController;
}
declare const _default: ProjectMetadata;
export default _default;
