"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _types_1 = require("../@types");
class AccessByAuth {
    constructor(rule) {
        this.rule = rule;
    }
    canAccess(req) {
        const isAuth = req.session && req.session.authenticated;
        if (this.rule.auth === _types_1.AuthStatus.LOGGED_IN) {
            return isAuth;
        }
        if (this.rule.auth === _types_1.AuthStatus.NOT_LOGGED_IN) {
            return !isAuth;
        }
        throw `Unsupported auth status "${this.rule.auth}"`;
    }
}
exports.default = AccessByAuth;
