"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class AccessByRole {
    constructor(rule) {
        this.rule = rule;
    }
    canAccess(req) {
        if (!req.session || !req.session.authenticated) {
            return false;
        }
        if (typeof this.rule.roles === 'string') {
            return req.session.role === this.rule.roles;
        }
        else {
            return this.rule.roles.indexOf(req.session.role) !== -1;
        }
    }
}
exports.default = AccessByRole;
